<script setup>
import AppShare from '@/helpers/AppShare'
import { useDialogStore } from '@/stores/DialogStore';
import Constants from '@/Constants'
</script>


<script>
export default {

	data() {
		return {
			email: this.$route.params.email,
			item: null,
			disable: null,
		}
	},

	methods: {
		async onSubmit(e) {
			const dialogStore = useDialogStore()
			const result = await dialogStore.waitBox(async () =>
				await AppShare.client.call(`admin/members/disable/${this.email}`, {
					method: 'PUT',
					headers: AppShare.client.defaultHeaders(),
					data: {
						member: {
							disabled: this.disable ? true : false,
						},
					},
				})
			)
			if (!dialogStore.handleRestError(result)) {
				this.$router.push({ name: 'members' })
			}
		},

		async refresh() {
			const dialogStore = useDialogStore()
			console.log(`mail: ${this.email}`)
			const result = await dialogStore.waitBox(async () =>
				await AppShare.client.call(`members/${this.email}`, {
					method: 'GET',
					headers: AppShare.client.defaultHeaders(),
				})
			)
			if (!dialogStore.handleRestError(result)) {
				this.item = result?.json.member
				this.disable = this.item.disabled ? true : false
			}
		},
	},

	mounted() {
		this.refresh()
	},

	i18n: {
		messages: {
			en: {
				title: (ctx) => `Edit ${ctx.named('name')}`,
				role: "Role",
				locale: "Locale",
				name: "Name",
				disabled: "Disabled",
				resigned: "Resigned",
				signup: "Sign Up",
				disable: "Disable",
				ok: "Save",
			},
			th: {
				title: (ctx) => `แก้ไข ${ctx.named('name')}`,
				role: "ประเภท",
				locale: "ภาษา",
				name: "ชื่อ",
				disabled: "ถูกปิดการทำงาน",
				resigned: "ลาออกจากระบบ",
				signup: "สมัครสมาชิก",
				disable: "ปิดการทำงาน",
				ok: "บันทึก",
			},
		},
	},
}
</script>


<template>
	<AuthenRequired>
		<AppBox :title="$t('title', { name: email })">
			<div v-if="item">
				<img :width="128" :height="128" :src="`${Constants.baseUrl}/members/${item.email}/icon`"
					:alt="item.email" :title="item.name" />
				<br />

				<h2><strong>{{  item.email  }}</strong></h2>
				<br />

				<table>
					<thead>
						<tr>
							<th>{{  $t('common.name')  }}</th>
							<th>{{  $t('common.value')  }}</th>
						</tr>
					</thead>
					<tbody>
						<tr>
							<td><span>{{  $t('role')  }}</span></td>
							<td><span>{{  item.role  }}</span></td>
						</tr>
						<tr>
							<td><span>{{  $t('locale')  }}</span></td>
							<td><span>{{  item.locale  }}</span></td>
						</tr>
						<tr>
							<td><span>{{  $t('name')  }}</span></td>
							<td><span>{{  item.name  }}</span></td>
						</tr>
						<tr>
							<td><span>{{  $t('disabled')  }}</span></td>
							<td><span>{{  item.disabled  }}</span></td>
						</tr>
						<tr>
							<td><span>{{  $t('resigned')  }}</span></td>
							<td><span>{{  item.resigned  }}</span></td>
						</tr>
						<tr>
							<td><span>{{  $t('signup')  }}</span></td>
							<td><span>{{  item.created  }}</span></td>
						</tr>
					</tbody>
				</table>
				<br />

				<b-form id="form" @submit.prevent="onSubmit">
					<b-form-group>
						<b-form-checkbox id="disable" type="checkbox" style="margin-right: 0.5rem" v-model="disable">
							<label for="disable">{{  $t('disable')  }}</label><br />
						</b-form-checkbox>
					</b-form-group>

					<b-form-group>
						<b-button class="mx-1" variant="primary" type="submit">{{  $t('ok')  }}</b-button>
						<b-button class="mx-1" variant="danger" type="button" @click.prevent="this.$router.go(-1)">{{
							 $t('common.cancel')  }}</b-button>
					</b-form-group>
				</b-form>
			</div>
		</AppBox>
	</AuthenRequired>
</template>


<style scoped>
table {
	border-collapse: collapse;
	border: 1px solid #999999;
}

table th {
	border: 1px solid #999999;
	padding: 0.75em 1.0em;
	font-weight: bold;
}

table td {
	border: 1px solid #999999;
	padding: 0.75em 1.0em;
}
</style>
